namespace PkmnLib.Plugin.Gen7.Scripts.Abilities;

/// <summary>
/// Liquid Voice is an ability that makes all sound-based moves become Water-type.
///
/// <see href="https://bulbapedia.bulbagarden.net/wiki/Liquid_Voice_(Ability)">Bulbapedia - Liquid Voice</see>
/// </summary>
[Script(ScriptCategory.Ability, "liquid_voice")]
public class LiquidVoice : Script, IScriptChangeMoveType
{
    /// <inheritdoc />
    public void ChangeMoveType(IExecutingMove move, IPokemon target, byte hit, ref TypeIdentifier? typeIdentifier)
    {
        if (move.UseMove.HasFlag(MoveFlags.Sound) &&
            move.Battle.Library.StaticLibrary.Types.TryGetTypeIdentifier("water", out var waterType))
        {
            typeIdentifier = waterType;
        }
    }
}